/*
 * Copyright (c) 2008, Koji Tsukada<tsuka@mobiquitous.com> 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
*/
using System;
using System.Collections.Generic;
using System.Text;

namespace MobiServer.Devices.X10.Data
{
    public delegate void ReadHandler(object sender,X10EventArgs e);
    public delegate void WriteHandler(object sender, X10EventArgs e);

    public class X10EventArgs : System.EventArgs
    {
        char houseCode;
        int unitCode;
        byte functionCode;
        int repeatCount;

        public X10EventArgs(char houseCode, int unitCode, byte functionCode, int repeatCount)
        {
            this.houseCode = houseCode;
            this.unitCode = unitCode;
            this.functionCode = functionCode;
            this.repeatCount = repeatCount;
        }


        public X10EventArgs(char houseCode, int unitCode, byte functionCode)
        {
            this.houseCode = houseCode;
            this.unitCode = unitCode;
            this.functionCode = functionCode;
            this.repeatCount = 0;
            //this.repeatCount = repeatCount;
        }
        
        public char HouseCode
        {
            get { return this.houseCode; }
        }

        public int UnitCode
        {
            get { return this.unitCode; }
        }

        public byte FunctionCode
        {
            get { return this.functionCode; }
        }
        public int RepeatCount
        {
            get { return this.repeatCount; }
        }
    }
}
